# mypy-boto3-docdb

[![PyPI - mypy-boto3-docdb](https://img.shields.io/pypi/v/mypy-boto3-docdb.svg?color=blue)](https://pypi.org/project/mypy-boto3-docdb)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-docdb.svg?color=blue)](https://pypi.org/project/mypy-boto3-docdb)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-docdb](#mypy-boto3-docdb)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.DocDB 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/docdb.html#DocDB) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-docdb](#mypy-boto3-docdb)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `DocDB` service.

```bash
python -m pip install boto3-stubs[docdb]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_docdb` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_docdb import DocDBClient

# Now mypy can check if your code is valid.
client: DocDBClient = boto3.client("docdb")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: DocDBClient = session.client("docdb")



# Waiters are also supported

import mypy_boto3_docdb.waiter as docdb_waiters

db_instance_available_waiter: docdb_waiters.DBInstanceAvailableWaiter = client.get_waiter("db_instance_available")
db_instance_deleted_waiter: docdb_waiters.DBInstanceDeletedWaiter = client.get_waiter("db_instance_deleted")


# Annotated paginators are included as well

import mypy_boto3_docdb.paginator as docdb_paginators

describe_db_clusters_paginator: docdb_paginators.DescribeDBClustersPaginator = client.get_paginator("describe_db_clusters")
describe_db_engine_versions_paginator: docdb_paginators.DescribeDBEngineVersionsPaginator = client.get_paginator("describe_db_engine_versions")
describe_db_instances_paginator: docdb_paginators.DescribeDBInstancesPaginator = client.get_paginator("describe_db_instances")
describe_db_subnet_groups_paginator: docdb_paginators.DescribeDBSubnetGroupsPaginator = client.get_paginator("describe_db_subnet_groups")
describe_events_paginator: docdb_paginators.DescribeEventsPaginator = client.get_paginator("describe_events")
describe_orderable_db_instance_options_paginator: docdb_paginators.DescribeOrderableDBInstanceOptionsPaginator = client.get_paginator("describe_orderable_db_instance_options")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_docdb` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_docdb as docdb
from mypy_boto3_docdb import DocDBClient

# with these
from mypy_boto3 import docdb
from mypy_boto3.docdb import DocDBClient
```